// Program pierwszego potomka, programu main, odpowiada za stworzenie drugiego 
// lacza nienazwanego miedzy grep wzor i wc -l 
// (c) Kacper Kulczycki 2007
//***************************************************************************
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include "err.h"
//***************************************************************************
int main(int argc, char *argv[])
{
 if (argc != 3)
        {
        fatal("Blad zdefiniowanych parametrow dla %s", argv[0]);
        }
 int write_descriptor;
 write_descriptor=atoi(argv[2]);
 int pipe_desc2[2];
 char pipe_write_descriptor2[1024]; 
 if (pipe (pipe_desc2) == -1)
	{
	 syserr("Blad podczas pipe!!!\n");
	}
 switch (fork()) 
	{
    	case -1:
      		syserr("Blad podczas fork!!!\n");   
    	case 0: //potomek
      		if (close (pipe_desc2[0]) == -1) //nie bedzie czytal
			{
			syserr("Blad podczas close(pipe_desc2[0])!!!\n");
           		}
      		sprintf(pipe_write_descriptor2, "%d", pipe_desc2[1]);
      		execl("./child2", "child2", pipe_write_descriptor2 , NULL);
      		syserr("Blad podczas execl(child2)!!!\n");
    	default: //rodzic
      		if (close (pipe_desc2[1]) == -1)  //nie bedzie pisal
			{
			syserr("Blad podczas close(pipe_desc2[1])\n");
      			}
		if (close (0) == -1) //zamkniecie stdin
                     	{
                       	syserr("Blad podczas close(0)!!!\n");
                       	}
		if (dup(pipe_desc2[0]) != 0) //duplikacja konca "wejsciowego" w miejsce stdin
                        {
                        syserr("Blad podczas dup(pipe_desc2[0])!!!");
                        }
                if (close (pipe_desc2[0]) == -1)// zamkniecie zbednego juz wejscia - bo zastapione stdin
                        {
                        syserr("Blad podczas close(pipe_desc2[0])!!!\n");
                        }
		 if (close (1) == -1) //zamkniecie stdout
                        {
                        syserr("Blad podczas close(1)!!!\n");
                        }
                if (dup(write_descriptor) != 1) //duplikacja konca "wyjsciowego" w miejsce stdout
                        {
                        syserr("Blad podczas dup(write_descriptor)!!!");
                        }
                if (close (write_descriptor) == -1)// zamkniecie zbednego juz wyjscia - bo zastapione stdout
                        {
                        syserr("Blad podczas close(read_descriptor)!!!\n");
                        }
		execlp("grep", "grep", argv[1], NULL);
                        syserr("Blad podczas execlp(grep)!!!\n");
  		if (close (1) == -1)
                        {
                        syserr("Blad podczas close(1)!!!\n");
                        }
 		if (close (0) == -1)
                        {
                        syserr("Blad podczas close(0)!!!\n");
                        }
                if (wait (0) == -1)
                        {
                        syserr("Blad podczas wait!!!\n");
                        }
   	   	exit (0);
  }
exit(0);
}

